	/* Standard C Includes */
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <dir.h>
#include <string.h>
#include <time.h>

	/* User Defined Includes */
#include "genutil.h"
#include "fileutil.h"


#define MAX_STRING_LENGTH 256
#define BUFFER_SIZE 60000u



/*========== Begin Main Program ===========================================*/
boolean main (int argv, char *argc[]) {
  FILE *f;	/* File pointer */
  struct ffblk file_block;
  int done;
  char search_string[MAX_STRING_LENGTH];
  char path[MAX_STRING_LENGTH];
  char *buffer;
  unsigned int size, count, num_files = 0;;
  short search_size;
  long l, total_size = 0;
  clock_t tick = clock();

//  clrscr();

	/* Enough arguments */
  if (argv < 3) {
    printf ("\nSEARCH v1.0, 31 May 1998 - by Dave Humphrey (aj589@freenet.carleton.ca)\n");
    printf ("     Search binary and text files for a text string. Is case insensitive,\n");
    printf ("accepts wildcards but does not parse through directories.\n\n");

    printf ("     Format: SEARCH [search string] [files]\n\n");
    return (FALSE);
   }

	/* First argument is the search string */
  strcpy (search_string, argc[1]);
  search_size = strlen(search_string);

	/* Second argument is the path and filter information */
  strcpy (path, argc[2]);

  printf ("\nSearching files '%s' for string '%s'\n", path, search_string);

	/* Find the first file */
  done = findfirst (path, &file_block, 0);

	/* Create the input buffer */
  buffer = create_ptr (BUFFER_SIZE);

  while (!done) {

	/* Check for key hits */
    if (kbhit()) {
      if (getch() == 27) {
	printf ("\n     Aborted!\n");
	break;
       }
     }

    delline();
    gotoxy (1, wherey());
    printf ("    Searching in file '%s'...", file_block.ff_name);
    total_size += file_block.ff_fsize;
    num_files++;

    f = openfile (file_block.ff_name, "rb");
    count = 0;

    if (f) {

      do {
	size = fread (buffer, sizeof(char), BUFFER_SIZE, f);
	l = 0;

	while ((l = strstr_bi(buffer, search_string, size, search_size, (unsigned)l + 1)) != -1) {
	  count++;
	 }

		/* In case the search string is on the buffer border */
	if (size == BUFFER_SIZE)
	  fseek (f, - search_size - 1, SEEK_CUR);
	else
	  break;

      } while (TRUE);

      if (count) {
	delline();
	gotoxy (1, wherey());
	printf ("  %s: Count = %d\n", file_block.ff_name, count);
       }

      fclose (f);
     }

    done = findnext (&file_block);
   }


	/* Destroy allocated memory */
  delete buffer;

  printf ("\nSearched %d files (%ld kb) in %d seconds.\n\n", num_files, total_size/1000, (int)((clock() - tick)/18.2));
  return (TRUE);
 }
/*========== End of Main Program ==========================================*/